<template>
  <!--UI上下文的展示器-->
  <div style="height:calc(100% - 4px);min-width:1200px">
    <el-header v-if="uiDefineVO.northAreas && uiDefineVO.northAreas.length>0">
      <UIContentArea :key="'northArea-'+uiDefineVO.oid" areas-name="northAreaInDialog"
                     :areasData="uiDefineVO.northAreas"
                     :inDialog="inDialog"
                     :sourceData="sourceData"
                     :dataStore="checkedData.northAreaInDialog"
                     :paramVOS="paramVOS"
                     @setDataStore="setDataStore">
      </UIContentArea>
    </el-header>
    <el-container :style="'height: '+(uiDefineVO.northAreas && uiDefineVO.northAreas.length>0?'calc(100% - 70px)':'100%')">
      <el-aside v-if="uiDefineVO.westAreas && uiDefineVO.westAreas.length>0" :width="uiDefineVO.westAreas[0].componentVOs[0].uiComponentType=='table' || uiDefineVO.westAreas[0].componentVOs[0].uiComponentType=='TreeTable'?'420px':'320px'" height="100%">
        <UIContentArea :key="'westArea-'+uiDefineVO.oid" areas-name="westAreaInDialog"
                       cradStyle=""
                       :areasData="uiDefineVO.westAreas"
                       :inDialog="inDialog"
                       :sourceData="sourceData"
                       :dataStore="checkedData.westAreaInDialog"
                       :paramVOS="paramVOS"
                       @setDataStore="setDataStore">
        </UIContentArea>
      </el-aside>
      <el-container style="height: 100%">
        <el-main v-if="uiDefineVO.centerAreas && uiDefineVO.centerAreas.length>0" :style="'height: '+centerHeight">
          <UIContentArea :key="'centerArea-'+uiDefineVO.oid" areas-name="centerAreaInDialog"
                         cradStyle=""
                         :areasData="uiDefineVO.centerAreas"
                         :inDialog="inDialog"
                         :sourceData="checkedData.westAreaInDialog[checkedData.westAreaInDialog.length-1]"
                         :dataStore="checkedData.centerAreaInDialog"
                         :paramVOS="paramVOS"
                         @setDataStore="setDataStore">
          </UIContentArea>
        </el-main>
        <el-footer v-if="uiDefineVO.southAreas && uiDefineVO.southAreas.length>0" height="35%" style="max-height: 300px">
          <UIContentArea :key="'southArea-'+uiDefineVO.oid" areas-name="southAreaInDialog"
                         cradStyle=""
                         :areasData="uiDefineVO.southAreas"
                         :inDialog="inDialog"
                         :sourceData="checkedData.centerAreaInDialog[checkedData.centerAreaInDialog.length-1]"
                         :dataStore="checkedData.southAreaInDialog"
                         :paramVOS="paramVOS"
                         @setDataStore="setDataStore">
          </UIContentArea>
        </el-footer>
      </el-container>
    </el-container>
  </div>
</template>

<script>
import UIContentArea from "@/views/base/UIContentArea"
import {uiDefineVOData} from "@/views/base/uiDefineVOInDialog"
import {verifyNull} from "@/util/validate";

export default {
  name: "UIContentViewerInDialog",
  components:{UIContentArea},
  props:{
    btmType:{
      type: String,
    },
    content:{
      type: String,
    },
    inDialog: {
      type: Boolean,
      default: false
    },
    sourceData:{
      //所属区域的上一区域选中数据
      type:Object,
      default: {}
    },
    dataStore:{
      //弹窗时按钮所属区域选中数据
      type:Array,
      default: []
    },
    paramVOS:{
      type:Object,
      default: {}
    }
  },
  data() {
    return {
      checkedData:{
        //各区域选中数据
        northAreaInDialog:[{}],
        westAreaInDialog:[{}],
        centerAreaInDialog:[{}],
        southAreaInDialog:[{}]
      },
      uiDefineVO: {},
      centerHeight:'100%'
    }
  },
  watch: {

  },
  computed: {

  },
  created() {
    if (verifyNull(this.btmType) || verifyNull(this.content) ) {
      this.$message.error("自定义组件配置的信息错误，请参考bs=name?type=xxx&context=yyy&param=zzz这种形式。其中type是业务类型（或链接类型），context是UI上下文的名称,name为组件名称，空值时默认展示UI引擎");
      return false;
    }
    this.initUI();
    this.initContent();
  },
  methods: {
    initUI() {
      this.uiDefineVO = uiDefineVOData;
    },
    initContent() {
      if (this.uiDefineVO.southAreas && this.uiDefineVO.southAreas.length > 0) {
        this.centerHeight = 'calc(100% - 310px)';
      } else {
        this.centerHeight = '100%';
      }
    },
    setDataStore(value) {
      this.checkedData[value.area] = value.dataStore;
    }
  }
}
</script>

<style scoped>
.el-container{
  padding: 0 !important;
}
.el-header,.el-aside,.el-main,.el-footer{
  padding: 0;
}
.el-header{
  margin-bottom: 10px;
}
</style>
